<template>
  <v-bottom-sheet
    :model-value="isShown"
    content-class="!shadow-none"
    class="w-full md:w-4/5 lg:w-2/3 xl:w-3/5 mx-auto"
    persistent
  >
    <v-card>
      <v-card-text class="!px-2 md:!px-6">
        <section class="flex justify-between items-center gap-2">
          <FormHeader
            icon="mdi-eye"
            headline="Новое бронирование"
            subtitle="Проверьте введенные данные"
          />

          <v-btn
            icon="mdi-close"
            variant="text"
            @click="onSummaryClose"
          />
        </section>

        <v-divider class="border-gray-800 my-4" />

        <v-timeline
          class="[&_.v-timeline-divider\_\_dot]:mt-[18px] [&_.v-timeline-item\_\_opposite]:hidden [&_.v-timeline-divider]:hidden md:[&_.v-timeline-divider]:flex [&_.v-timeline-item\_\_body]:!p-0 md:[&_.v-timeline-item\_\_body]:!pl-6 md:[&_.v-timeline-item\_\_body]:!pt-6"
          density="comfortable"
          align="start"
          side="end"
          dot-color="grey"
          size="20"
          fill-dot
          hide-opposite
        >
          <v-timeline-item
            width="100%"
            side="end"
          >
            <v-sheet border>
              <v-list-item
                subtitle="Информация, обязательная для бронирования"
                lines="two"
              >
                <template #title>
                  <strong class="text-2xl">
                    Основная информация
                  </strong>
                </template>
              </v-list-item>

              <v-table
                density="compact"
                class="text-base [&_table]:table-fixed [&_th]:align-text-top [&_td]:align-text-top"
              >
                <tbody>
                  <tr v-if="booking.property">
                    <th>
                      <strong>Объект:</strong>
                    </th>

                    <td class="text-right">
                      <section class="inline-flex items-center gap-2">
                        <section
                          class="min-w-3 min-h-3 rounded-full"
                          :style="{ 'background-color': booking.property.color }"
                        />

                        <section>
                          {{ booking.property.name }}
                        </section>
                      </section>
                    </td>
                  </tr>

                  <tr v-if="booking.dates">
                    <th class="py-2">
                      <strong>Начало:</strong>
                    </th>

                    <td class="text-right py-2">
                      {{ dt.display(booking.dates.start, 'cccc, d MMMM') }}
                    </td>
                  </tr>

                  <tr v-if="booking.dates">
                    <th class="py-2">
                      <strong>Завершение:</strong>
                    </th>

                    <td class="text-right py-2">
                      {{ dt.display(booking.dates.end, 'cccc, d MMMM') }}
                    </td>
                  </tr>

                  <tr v-if="booking.dates">
                    <th class="py-2">
                      <strong>Длительность:</strong>
                    </th>

                    <td class="text-right py-2">
                      {{ bookingNightsCount }} {{ getNightsLabel(bookingNightsCount) }}
                    </td>
                  </tr>

                  <tr v-if="booking.rate">
                    <th class="py-2">
                      <strong>Выбранный тариф:</strong>
                    </th>

                    <td class="text-right py-2">
                      <section>
                        {{ booking.rate.name }}
                      </section>

                      <section class="text-gray-500">
                        {{ booking.rate.profit }} / чел
                      </section>
                    </td>
                  </tr>

                  <tr v-if="booking.guests.contact">
                    <th class="py-2">
                      <strong>Контактное лицо:</strong>
                    </th>

                    <td class="text-right py-2">
                      <section>
                        {{ booking.guests.contact.name }}
                      </section>

                      <section
                        v-if="booking.guests.contact.phones.length"
                        class="text-gray-500"
                      >
                        {{
                          getFormattedPhoneNumber(
                            booking.guests.contact.phones.at(0)!.value
                          )
                        }}
                      </section>

                      <section
                        v-else
                        class="text-gray-500"
                      >
                        Номер телефона не указан
                      </section>
                    </td>
                  </tr>

                  <tr v-if="booking.guests.count">
                    <th class="py-2">
                      <strong>Взрослых:</strong>
                    </th>

                    <td class="text-right py-2">
                      {{ booking.guests.count.adults }}
                    </td>
                  </tr>

                  <tr v-if="booking.guests.count">
                    <th class="py-2">
                      <strong>Детей:</strong>
                    </th>

                    <td class="text-right py-2">
                      {{ booking.guests.count.children }}
                    </td>
                  </tr>

                  <tr
                    v-if="booking.guests.count && isCapacityExceedShown"
                    class="bg-yellow-50 text-yellow-600"
                  >
                    <td
                      class="text-sm px-8 py-2"
                      colspan="2"
                    >
                      Указанное число гостей (<b>
                        {{ booking.guests.count.adults + booking.guests.count.children }}
                      </b>) превышает максимальную вместимость выбранного объекта
                      (<b>{{ booking.property!.capacity }}</b>)
                    </td>
                  </tr>

                  <tr class="bg-gray-50">
                    <th class="py-4">
                      <strong>Подытог:</strong>
                    </th>

                    <td class="text-right text-lg py-4">
                      <ProfitDisplay
                        :value="generalSummerValue"
                        mode="plain"
                        disable-label
                      />
                    </td>
                  </tr>
                </tbody>
              </v-table>
            </v-sheet>
          </v-timeline-item>

          <v-timeline-item
            v-if="booking.amenities.length"
            width="100%"
            side="end"
          >
            <v-sheet border>
              <v-list-item
                subtitle="Выбраны дополнительные услуги"
                lines="two"
              >
                <template #title>
                  <strong class="text-2xl">
                    Услуги
                  </strong>
                </template>
              </v-list-item>

              <v-table
                density="compact"
                class="text-base [&_table]:table-fixed [&_th]:align-text-top [&_td]:align-text-top"
              >
                <tbody>
                  <tr
                    v-for="amenity in getSortedAmenities(booking.amenities)"
                    :key="amenity.id"
                  >
                    <th class="py-2">
                      <span>[x{{ amenity.quantity }}]</span>
                      <b class="ml-2">{{ amenity.name }}</b>
                    </th>

                    <td class="text-right py-2">
                      <ProfitDisplay
                        :value="Number(amenity.profit) * amenity.quantity"
                        mode="plain"
                      />
                    </td>
                  </tr>

                  <tr class="bg-gray-50">
                    <th class="py-4">
                      <strong>Подытог:</strong>
                    </th>

                    <td class="text-right text-lg py-4">
                      <ProfitDisplay
                        :value="amenitiesSummerValue"
                        mode="plain"
                        disable-label
                      />
                    </td>
                  </tr>
                </tbody>
              </v-table>
            </v-sheet>
          </v-timeline-item>

          <v-timeline-item
            v-if="booking.corrections.length"
            width="100%"
            side="end"
          >
            <v-sheet border>
              <v-list-item
                subtitle="Указаны коррекции итоговой цены"
                lines="two"
              >
                <template #title>
                  <strong class="text-2xl">
                    Коррекции
                  </strong>
                </template>
              </v-list-item>

              <v-table
                density="compact"
                class="text-base [&_table]:table-fixed [&_th]:align-text-top [&_td]:align-text-top"
              >
                <tbody>
                  <tr
                    v-for="correction in getSortedCorrections(booking.corrections)"
                    :key="correction.id"
                  >
                    <th class="py-2">
                      {{ correction.reason }}
                    </th>

                    <td class="text-right py-2">
                      <ProfitDisplay
                        :value="correction.value"
                        mode="plain"
                      />
                    </td>
                  </tr>

                  <tr class="bg-gray-50">
                    <th class="py-4">
                      <strong>Подытог:</strong>
                    </th>

                    <td class="text-right text-lg py-4">
                      <ProfitDisplay
                        :value="correctionsSummerValue"
                        mode="plain"
                        disable-label
                      />
                    </td>
                  </tr>
                </tbody>
              </v-table>
            </v-sheet>
          </v-timeline-item>

          <v-timeline-item
            v-if="booking.comment"
            width="100%"
            side="end"
          >
            <v-sheet border>
              <v-list-item
                subtitle="Дополнительные уточнения"
                lines="two"
              >
                <template #title>
                  <strong class="text-2xl">
                    Комментарий
                  </strong>
                </template>
              </v-list-item>

              <v-textarea
                :model-value="booking.comment"
                prepend-inner-icon="mdi-comment-edit-outline"
                class="px-4 pb-4"
                variant="plain"
                rows="2"
                readonly
                hide-details
                auto-grow
                flat
              />
            </v-sheet>
          </v-timeline-item>

          <v-timeline-item
            width="100%"
            side="end"
          >
            <v-sheet border>
              <v-list-item
                subtitle="Прибыль от основных и дополнительных услуг"
                lines="two"
              >
                <template #title>
                  <strong class="text-2xl">
                    Итого
                  </strong>
                </template>
              </v-list-item>

              <section class="p-4">
                <ProfitDisplay
                  :value="resultSummerValue"
                  mode="display"
                  disable-label
                />
              </section>
            </v-sheet>
          </v-timeline-item>
        </v-timeline>

        <Feedback
          :message="feedback"
          type="error"
          classes="mt-4"
        />

        <v-divider class="border-gray-800 my-4" />

        <FormRow
          spacing="large"
          class="grid grid-cols-12 gap-4 w-3/5 mx-auto"
        >
          <v-btn
            rounded
            size="large"
            variant="tonal"
            :ripple="false"
            class="col-span-12 md:col-span-6 order-2 md:order-1"
            @click="onSummaryClose"
          >
            Назад
          </v-btn>

          <v-btn
            rounded
            size="large"
            class="col-span-12 md:col-span-6 order-1 md:order-2 text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
            :loading="isLoading"
            @click="onCreateClick"
          >
            Создать
          </v-btn>
        </FormRow>
      </v-card-text>
    </v-card>
  </v-bottom-sheet>
</template>

<script setup lang="ts">
import { computed, ref } from 'vue';

import { useDateTime } from '@/composables';
import { useBookingsStore } from '@/stores';
import { getFormattedPhoneNumber, getNightsCount, getNightsLabel } from '@/utils';

import FormRow from '@/components/layout/FormRow.vue';
import FormHeader from '@/components/layout/FormHeader.vue';
import Feedback from '@/components/content/Feedback.vue';
import ProfitDisplay from '@/components/content/ProfitDisplay.vue';

type SummaryProps = {
  booking: INewBooking;
  isShown: boolean;
}

const props = defineProps<SummaryProps>();
const emit = defineEmits(['close', 'bookingCreate']);

const dt = useDateTime();
const bookingsStore = useBookingsStore();

const isLoading = ref(false);
const feedback = ref('');

const isCapacityExceedShown = computed(() => {
  if (!props.booking.property) return false;

  const maxCapacity = props.booking.property.capacity;
  const adults = props.booking.guests.count.adults;
  const children = props.booking.guests.count.children;

  return adults + children > maxCapacity;
});

const bookingNightsCount = computed(() => {
  const startDate = props.booking.dates?.start;
  const endDate = props.booking.dates?.end;

  if (!startDate || !endDate) return 0;
  return getNightsCount(startDate, endDate);
});

const generalSummerValue = computed(() => {
  const rateProfit = props.booking.rate?.profit ?? 0;
  const adultsCount = props.booking.guests.count.adults;

  return Number(rateProfit) * adultsCount * bookingNightsCount.value;
});

const amenitiesSummerValue = computed(() => {
  return props.booking.amenities.reduce((result, amenity) => {
    return result + Number(amenity.profit) * amenity.quantity;
  }, 0);
});

const correctionsSummerValue = computed(() => {
  return props.booking.corrections.reduce((result, correction) => {
    return result + Number(correction.value);
  }, 0);
});

const resultSummerValue = computed(() => {
  return (
    generalSummerValue.value +
    amenitiesSummerValue.value +
    correctionsSummerValue.value
  );
});

const getSortedAmenities = (amenities: IBookingAmenity[]) => {
  return amenities.toSorted((amenityA, amenityB) => {
    return (
      Number(amenityB.profit) * amenityB.quantity -
      Number(amenityA.profit) * amenityA.quantity
    );
  });
};

const getSortedCorrections = (corrections: IProfitCorrection[]) => {
  return corrections.toSorted(({ value: valueA }, { value: valueB }) => {
    return Number(valueB) - Number(valueA);
  });
};

const onSummaryClose = () => {
  emit('close');
};

const onCreateClick = async () => {
  isLoading.value = true;

  const { data: { error } } = await bookingsStore.createBooking(props.booking);

  isLoading.value = false;

  if (error) {
    feedback.value = error.message;
    return;
  }

  emit('bookingCreate');
};
</script>